function Xconvolved_weighted_store = Compute_Convolution_Paral(X,D,attenuation)
% X: One original image (2D image)
% Y: Corresponding mask w.r.t X (2D image)
numFilters = size(D,3);
winsize = size(D,1);

Xconvolved_weighted_store = cell(1,size(X,3));
parfor kk = 1:size(X,3)
    X_single = X(:,:,kk);
    Xconvolved_weighted_store_single = zeros(size(X_single,1)-winsize+1,size(X_single,2)-winsize+1,numFilters);
    for ii = 1:numFilters
        feature = flipud(fliplr(D(:,:,ii)));
        Xconvolved = conv2(X_single,feature,'valid');
        Xconvolved_weighted_store_single(:,:,ii) = sigmoid(attenuation * Xconvolved);
    end
    Xconvolved_weighted_store{1,kk} = Xconvolved_weighted_store_single;
end
